/* general */

/* replace MPI_Abort by exit in the single thread case */
#if PARALLEL_FLAG
#include <mpi.h>
#else
#define MPI_Abort(xx,yy) exit(yy)
#endif

#include <unistd.h>
/* error routine,
 * JS2011-07-04: let the slaves wait 2s for extra messages from the master?
 */
#define ERR(msg) { printf("\nERROR %s L%d: %s\n",__FILE__,__LINE__,#msg); \
 if(myid)sleep(2);MPI_Abort(MPI_COMM_WORLD,1); }

/* main */

void input(int run_option, char *ccmfile, int argn, char *argv[]); // JS1002 add args
void define(void);
void obtain(void);


/* define */

void recursiveClusteringFunction(int (*configuration)[5], 
				 int length, 
				 int maxorder, 
				 int *NumberConnected);

/* bookKeeping */

int seconds(void);
void initDescr(int s2); // initialization for description code

int findDescriptorOfCluster(int order,
             int (*configuration)[5], int *descriptor); // new 0606

// Mar09 JS unified generalized function
int findDescriptorIndex(int *descriptor, struct spinConfigs *table, int numCfgs);

void printOutDescriptor(int *descriptor);
void printOutClusterFromDescriptor(int *descriptor);
void printOutConfig(int (*configuration)[5], int length);

void symmetryGroup(int switchVariable, int order,
		   int (*configuration)[5],  // changed by Joerg Jun06
		   int (*tempConfiguration)[5]); // changed by Joerg Sep05


void findCartesiansFromGeneralisedPosition(double *x, double *y, double *z,
					   int *configuration);

// null x y z uc, ret:0=ok -1=error
int findConfigurationToDescriptor(int *descriptor, int (*config)[5], 
         int order); 

int findClusterFromDescriptor(int *descriptor, int (*configuration)[5]);

void   binary(int index,  int length, int *spin);
void  trimary(int index1, int index2, int index3, int length, int *spin);

/* new routines for higher spin + define */

int findDescriptorIndex2(int *descriptor,int numberElements);
void findSpinState(int *descriptor, int *spinState);

/* collect */

void collect(void);

/* solve */

void solve(void);
void usrfun(int n, double *fvec, double **fjac, double *x, 
		     int iterations);

void definePointsInBT(void);

/* find generalised expectation values */

void obtainGenExp(void);
void findGenExp(double *x, double *bra_x, double *g_exp, double *alpha);
